--- fileutils-4.1.9/src/remove.c.bero	Fri Aug 30 00:08:52 2002
+++ fileutils-4.1.9/src/remove.c	Fri Aug 30 00:20:12 2002
@@ -558,15 +558,23 @@
 	enum Prompt_action mode, Ternary *is_dir, Ternary *is_empty)
 {
   int write_protected = 0;
+  struct stat sbuf, sbuf0;
+  int _stat;
   *is_empty = T_UNKNOWN;
   *is_dir = T_UNKNOWN;
+  _stat=lstat(filename, &sbuf);
+
+  // Handle the special case of dangling/recursive symlinks - they shouldn't
+  // appear write protected.
+  write_protected = euidaccess (filename, W_OK);
+  if(write_protected && S_ISLNK(sbuf.st_mode) && stat(filename, &sbuf0))
+	  write_protected=0;
 
   if ((!x->ignore_missing_files && (x->interactive || x->stdin_tty)
-       && (write_protected = euidaccess (filename, W_OK)))
+       && write_protected)
       || x->interactive)
     {
-      struct stat sbuf;
-      if (lstat (filename, &sbuf))
+      if (_stat)
 	{
 	  /* lstat failed.  This happens e.g., with `rm '''.  */
 	  error (0, errno, _("cannot lstat %s"),
